'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('jujulib terms service',function(){let a=[];var b=function(c){return{target:{responseText:JSON.stringify(c)}}};afterEach(function(){a.forEach(c=>{c()})}),it('exists',function(){var c=new window.jujulib.terms('http://1.2.3.4/',{});assert.strictEqual(c instanceof window.jujulib.terms,!0),assert.strictEqual(c.url,'http://1.2.3.4/'+window.jujulib.termsAPIVersion)}),it('is smart enough to handle missing trailing slash in URL',function(){var c=new window.jujulib.terms('http://1.2.3.4',{});assert.strictEqual(c.url,'http://1.2.3.4/'+window.jujulib.termsAPIVersion)}),it('shows terms with revision',function(c){var d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:function(e,f){assert.equal(e,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/terms/canonical?revision=42');var g=b([{name:'canonical',owner:'spinach',title:'canonical terms',revision:42,'created-on':'2016-06-09T22:07:24Z',content:'Terms and conditions'}]);f(g)}});d.showTerms('canonical',42,function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{name:'canonical',owner:'spinach',title:'canonical terms',revision:42,createdAt:new Date(1465510044000),content:'Terms and conditions'}),c()})}),it('shows most recent terms',function(c){var d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:function(e,f){assert.equal(e,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/terms/canonical');var g=b([{name:'canonical',owner:'spinach',title:'canonical recent terms',revision:47,'created-on':'2016-06-09T22:07:24Z',content:'Terms and conditions'}]);f(g)}});d.showTerms('canonical',null,function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{name:'canonical',owner:'spinach',title:'canonical recent terms',revision:47,createdAt:new Date(1465510044000),content:'Terms and conditions'}),c()})}),it('handles missing terms',function(c){var d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:function(e,f){var g=b([]);f(g)}});d.showTerms('canonical',null,function(e,f){assert.strictEqual(e,null),assert.strictEqual(f,null),c()})}),it('handles errors fetching terms',function(c){var d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:function(e,f,g){var h=b({Message:'bad wolf'});g(h)}});d.showTerms('canonical',null,function(e,f){assert.equal(e,'bad wolf'),assert.strictEqual(f,null),c()})}),it('handles adding an agreement',function(c){var d=new window.jujulib.terms('http://1.2.3.4/',{sendPostRequest:function(e,f,g){assert.equal(e,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement');var h=b({agreements:[{user:'spinach',term:'these-terms',revision:42,'created-on':'2016-06-09T22:07:24Z'}]});g(h)}});d.addAgreement([{name:'canonical',revision:5}],function(e,f){assert.equal(e,null),assert.deepEqual(f,[{owner:null,user:'spinach',term:'these-terms',revision:42,createdAt:new Date(1465510044000),name:void 0,owner:void 0,content:void 0}]),c()})}),it('passes the agreements request the correct args',function(){const c=sinon.stub(window.jujulib,'_makeRequest');a.push(c.restore);var d=new window.jujulib.terms('http://1.2.3.4/',{});d.addAgreement([{name:'canonical',owner:'spinach',revision:5}]),assert.equal(c.callCount,1),assert.deepEqual(c.args[0][3][0],{termname:'canonical',termowner:'spinach',termrevision:5})}),it('can get agreements for a user',function(c){var d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:function(e,f){assert.equal(e,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreements');var g=b([{user:'spinach',term:'One fancy term',revision:47,'created-on':'2016-06-09T22:07:24Z'}]);f(g)}});d.getAgreements(function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,[{owner:void 0,user:'spinach',term:'One fancy term',revision:47,createdAt:new Date(1465510044000),name:void 0,owner:void 0,content:void 0}]),c()})}),it('handles missing agreements',function(c){var d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:function(e,f){var g=b([]);f(g)}});d.getAgreements(function(e,f){assert.strictEqual(e,null),assert.strictEqual(f,null),c()})}),it('handles errors fetching agreements',function(c){var d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:function(e,f,g){var h=b({Message:'bad wolf'});g(h)}});d.getAgreements(function(e,f){assert.equal(e,'bad wolf'),assert.strictEqual(f,null),c()})}),describe('getAgreementsByTerms',()=>{it('makes a proper request with a single term supplied',c=>{const d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:(e,f)=>{assert.equal(e,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement?Terms=hatch/test-term1'),f(b([{'created-on':'2016-06-09T22:07:24Z',content:'I am term1\n',id:'hatch/test-term1',name:'test-term1',owner:'hatch',published:!0,revision:2}]))}});d.getAgreementsByTerms(['hatch/test-term1'],(e,f)=>{assert.strictEqual(e,null),assert.deepEqual(f,[{content:'I am term1\n',createdAt:new Date(1465510044000),name:'test-term1',owner:'hatch',revision:2,term:void 0,user:void 0}]),c()})}),it('makes a proper request with multiple terms supplied',c=>{const d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:(e,f)=>{assert.equal(e,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement?Terms=hatch/test-term1&Terms=hatch/test-term2'),f(b([{'created-on':'2016-06-09T22:07:24Z',content:'I am term1\n',name:'test-term1',owner:'hatch',published:!0,revision:2}]))}});d.getAgreementsByTerms(['hatch/test-term1','hatch/test-term2'],(e,f)=>{assert.strictEqual(e,null),assert.deepEqual(f,[{content:'I am term1\n',createdAt:new Date(1465510044000),name:'test-term1',owner:'hatch',revision:2,term:void 0,user:void 0}]),c()})}),it('handles failures fetching agreements',c=>{const d=new window.jujulib.terms('http://1.2.3.4/',{sendGetRequest:(e,f,g)=>{g(b({Message:'it broke'}))}});d.getAgreementsByTerms(['user/termname'],(e,f)=>{assert.equal(e,'it broke'),assert.strictEqual(f,null),c()})})})});